package com.tutosoftware.musicmanager.action;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletContext;

import org.apache.commons.io.FileUtils;
import org.apache.struts2.util.ServletContextAware;

import com.opensymphony.xwork2.ActionSupport;
import com.tutosoftware.musicmanager.dao.CancionDAO;
import com.tutosoftware.musicmanager.dao.impl.CancionDAOImpl;
import com.tutosoftware.musicmanager.model.Cancion;

public class MusicaAction extends ActionSupport implements ServletContextAware{
	private static final long serialVersionUID = 1L;

	private String nombreCancion;
	private String artista;
	private String album;
	private File fileUpload;
	private String fileUploadContentType;
	private String fileUploadFileName;
	private ServletContext servletContext;
	//private String destPath;
	Cancion cancion = new Cancion();
	CancionDAO cancionDAO = new CancionDAOImpl();
	List<Cancion> listCancion = new ArrayList<Cancion>();
	
	@Override
    public String execute() throws Exception {
       
		
		try {
            //Ruta en raz donde subira el mp3
			String filePath = servletContext.getRealPath("/").concat("musica");
			System.out.println("Image location:" + filePath);
			File fileToCreate = new File(filePath, this.fileUploadFileName);

			FileUtils.copyFile(this.fileUpload, fileToCreate);
		} catch (Exception e) {
			e.printStackTrace();
			return INPUT;
		}
		
		
		
		
	 
	      
		  cancion.setNombreCancion(nombreCancion);
		  cancion.setArtista(artista);
		  cancion.setAlbum(album);
	      cancion.setNombreArchivo(fileUploadFileName);
		  cancion.setRutaArchivo("/musica/");
		  cancionDAO.guardarCancion(cancion);
		
		  listCancion = cancionDAO.obtenerCanciones();
		  
		  
        return ActionSupport.SUCCESS;
    }
	

	
	
	
	@Override
	public void validate() {
        if (null == nombreCancion || nombreCancion.length() == 0)
            addActionError(getText("error.nombrecancion.requerido"));
        if (null == artista || artista.length() == 0)
            addActionError(getText("error.artista.requerido"));
        if (null == fileUploadFileName)
            addActionError(getText("error.nombrearchivo.requerido"));
    }
	
	
   
	
	
	
	public String getNombreCancion() {
		return nombreCancion;
	}
	public void setNombreCancion(String nombreCancion) {
		this.nombreCancion = nombreCancion;
	}
	public String getArtista() {
		return artista;
	}
	public void setArtista(String artista) {
		this.artista = artista;
	}
	public String getAlbum() {
		return album;
	}
	public void setAlbum(String album) {
		this.album = album;
	}
	public File getFileUpload() {
		return fileUpload;
	}
	public void setFileUpload(File fileUpload) {
		this.fileUpload = fileUpload;
	}
	public String getFileUploadContentType() {
		return fileUploadContentType;
	}
	public void setFileUploadContentType(String fileUploadContentType) {
		this.fileUploadContentType = fileUploadContentType;
	}
	public String getFileUploadFileName() {
		return fileUploadFileName;
	}
	public void setFileUploadFileName(String fileUploadFileName) {
		this.fileUploadFileName = fileUploadFileName;
	}





	public List<Cancion> getListCancion() {
		return listCancion;
	}





	public void setListCancion(List<Cancion> listCancion) {
		this.listCancion = listCancion;
	}
	
	
	public void setServletContext(ServletContext context) {
		servletContext=context;
	}
	
	


}
