package com.tutosoftware.musicmanager.util;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.boot.registry.StandardServiceRegistryBuilder;
import org.hibernate.cfg.Configuration;
import org.hibernate.service.ServiceRegistry;

import com.tutosoftware.musicmanager.model.Cancion;



public class HibernateSession {
	private static final SessionFactory sessionFactory = buildSessionFactory();
	private static Session session;
	
	
	private static SessionFactory buildSessionFactory(){
		Configuration configuration = new Configuration();
		configuration.configure();
		configuration.addClass(Cancion.class);
		ServiceRegistry serviceRegistry = new StandardServiceRegistryBuilder()
				.applySettings(configuration.getProperties())
				.build();
		
		
		SessionFactory sessionFactory = configuration.buildSessionFactory(serviceRegistry);
		
		return sessionFactory;
		
		
		
	}
	
	public static SessionFactory getSessionFactory(){
		return sessionFactory;
	}
	
    public static Session getSession(){
    	if(null == session){
    		session = sessionFactory.openSession();
    	}
    	return session;
    }

}
